// ode3dsloader-0.0 by Kosei Demura 2007-11-01
// 3dsloader.cpp 
// 3dstH[}bgōꂽIuWFNgODEdrawstuffŕ\vO
// oOFP3Df̃IuWFNgō\ĂƃG[ɂȂB
// lib3dsCuKv@http://lib3ds.sourceforge.net/
#include "ode3dsloader.h"

#define SHRINK       0.1   // k
#define BASE_LENGTH  1.0   // bVf̍ő咷
#define MAX_OBJECTS  1000  // IuWFNg̐


typedef struct 
{
    float *vertices;
    unsigned int vertexCount;
    int *indices;
    unsigned int indexCount;
} MyTrimesh;

extern MyTrimesh *trimesh;

dReal MIN_X = dInfinity, MAX_X = - dInfinity;
dReal MIN_Y = dInfinity, MAX_Y = - dInfinity;
dReal MIN_Z = dInfinity, MAX_Z = - dInfinity;
dReal ADJUST;  
Lib3dsFile *file=0;

int MeshCount  = 0;

int vCount[MAX_OBJECTS], iCount[MAX_OBJECTS];

void calModel(Lib3dsMesh *mesh, int *points, int *faces)
{
	*points = mesh->points;
	*faces  = mesh->faces;
}

int meshDump(int no, Lib3dsMesh *mesh)
{
	if (mesh->points == 0) return 0;

	#ifdef DEBUG
	printf("\nObject No.%d \n", no);
  printf("point list: %d\n", mesh->points);
	#endif 

  for (int i=0; i< (int) mesh->points; i++) {
  	trimesh[no].vertices[3*i]   = mesh->pointL[i].pos[0];
 		trimesh[no].vertices[3*i+1] = mesh->pointL[i].pos[1];
 		trimesh[no].vertices[3*i+2] = mesh->pointL[i].pos[2];
		if (MIN_X > mesh->pointL[i].pos[0]) MIN_X = mesh->pointL[i].pos[0];
		if (MIN_Y > mesh->pointL[i].pos[1]) MIN_Y = mesh->pointL[i].pos[1];
		if (MIN_Z > mesh->pointL[i].pos[2]) MIN_Z = mesh->pointL[i].pos[2];
		if (MAX_X < mesh->pointL[i].pos[0]) MAX_X = mesh->pointL[i].pos[0];
		if (MAX_Y < mesh->pointL[i].pos[1]) MAX_Y = mesh->pointL[i].pos[1];
		if (MAX_Z < mesh->pointL[i].pos[2]) MAX_Z = mesh->pointL[i].pos[2];
		#ifdef DEBUG
		printf ("[%3d]   %4.1f  %4.1f  %4.1f\n", i, trimesh[no].vertices[3*i], 
			trimesh[no].vertices[3*i+1], trimesh[no].vertices[3*i+2]);
		#endif
  }
	
	#ifdef DEBUG
  printf("\nfacelist: %d\n", mesh->faces);
	#endif
  for (int i=0; i< (int) mesh->faces; i++) {
    trimesh[no].indices[3*i]   = mesh->faceL[i].points[0];
    trimesh[no].indices[3*i+1] = mesh->faceL[i].points[1];
    trimesh[no].indices[3*i+2] = mesh->faceL[i].points[2];
		#ifdef DEBUG
    printf("[%3d] %3d %3d %3d \n", i, trimesh[no].indices[3*i],
		 trimesh[no].indices[3*i+1], trimesh[no].indices[3*i+2]);
		#endif
  }
	return 1;
}

int normalize(int no, Lib3dsMesh *mesh)
{
	if (mesh->points == 0) return 0;

	for (int i=0; i< (int) mesh->points; i++) {
  	trimesh[no].vertices[3*i]   *= (dReal) ADJUST;
 		trimesh[no].vertices[3*i+1] *= (dReal) ADJUST;
 		trimesh[no].vertices[3*i+2] *= (dReal) ADJUST;
	}
	return 1;
}

void load3dsModel(const char *filename)
{
  int points, faces, no;
  Lib3dsMesh *p;
	
  file = lib3ds_file_load(filename);
  if (!file) {
    puts("3dsplayer: Error: Loading 3DS file failed.\n");
    exit(1);
  }

	// exit(1);
  for (p=file->meshes; p!=0; p=p->next) {
    calModel(p, &points, &faces);
 		if (points == 0) continue;
		// printf("vcount=%d icount=%d \n",vCount[MeshCount],iCount[MeshCount]);
		MeshCount++;
  }
	// printf("MeshCount=%d \n", MeshCount);

	trimesh   = (MyTrimesh *) malloc(MeshCount * sizeof(MyTrimesh));
	no = 0;
 	for (p=file->meshes; p!=0; p=p->next) {
    calModel(p, &points, &faces);
	  if (points == 0) continue;

    vCount[no] = points;
	  iCount[no] = faces;	
		trimesh[no].vertices = (float *) malloc(vCount[no]  * sizeof(float) * 3);
		trimesh[no].indices  = (int *)   malloc(iCount[no]  * sizeof(int) * 3);
		trimesh[no].vertexCount = vCount[no];
		trimesh[no].indexCount  = iCount[no];
		no++;
  }

	no = 0;
  for (p=file->meshes; p!=0; p=p->next) {
 		if (meshDump(no, p)) no++;
  }

	dReal maxLength;

	if (MAX_X - MIN_X >= MAX_Y - MIN_Y) {
		if (MAX_X - MIN_X >= MAX_Z - MIN_Z) maxLength = MAX_X - MIN_X;
		else                                maxLength = MAX_Z - MIN_Z;
	}
	else {
		if (MAX_Y - MIN_Y >= MAX_Z - MIN_Z) maxLength = MAX_Y - MIN_Y;
		else                                maxLength = MAX_Z - MIN_Z;
	}

	ADJUST = BASE_LENGTH / maxLength;
	// printf("ADJUST=%f maxLength=%f \n", ADJUST, maxLength);

	no = 0;
  for (p=file->meshes; p!=0; p=p->next) {
    if (normalize(no, p)) no++;
	}
}